# fastmath/fastmath.pxd
from libc.stdint cimport uint64_t, uint32_t, int32_t
cdef extern from "cfastmath.h":
    double divide(double a, double b)
    uint64_t factorial(uint32_t n)
    uint64_t combination(uint32_t n, uint32_t k)
    uint64_t permutation(uint32_t n, uint32_t k)
    int32_t gcd(int32_t a, int32_t b)
    int32_t lcm(int32_t a, int32_t b)
    int32_t abs_int(int32_t value)
    double mean(const double *values, uint32_t count)
    double median(double *values, uint32_t count)
    double population_variance(const double *values, uint32_t count)
    double sample_variance(const double *values, uint32_t count)
    double population_standard_deviation(const double *values, uint32_t count)
    double sample_standard_deviation(const double *values, uint32_t count)
    double min(const double *arr, uint32_t size)
    double max(const double *arr, uint32_t size)
    double sum(const double *arr, uint32_t size)
    double z_score(double value, double mean, double stddev)
    double normal_pdf(double x, double mu, double sigma)
    double normal_cdf(double x, double mu, double sigma)
    void add_array(const double *a, const double *b, double *out, uint32_t n)
    void scalar_multiply(const double *a, double scalar, double *out, uint32_t n)
    double dot(const double *a, const double *b, uint32_t n)